//
// Created by Tom on 24/03/2023.
//

#ifndef TYPON_BASEDEF_HPP
#define TYPON_BASEDEF_HPP

template<typename Self>
class TyBuiltin {
  template <typename... Args>
  auto sync_wrapper(Args&&... args)
  {
    return static_cast<Self*>(this)->sync(std::forward<Args>(args)...);
  }

public:
  template <typename... Args>
  auto operator()(Args&&... args) -> decltype(sync_wrapper(std::forward<Args>(args)...))
  {
    return sync_wrapper(std::forward<Args>(args)...);
  }
};

#endif // TYPON_BASEDEF_HPP
