from typon import fork, sync

def fibo(n: int) -> int:
    if n < 2:
        return n
    a = fork(lambda: fibo(n - 1))
    b = fork(lambda: fibo(n - 2))
    sync()

    return a.get() + b.get()
"""
def fibo(n: int) -> int:
    if n < 2:
        return n
    with sync(): # {
        a = fork(lambda: fibo(n - 1))
        b = fork(lambda: fibo(n - 2))
    # }
    return a + b
    """
"""
Task<int> fibo(int n) {
    if (n < 2) {
        return n;
    }
    Forked<int> a;
    Forked<int> b;
    {
        a = fork(fibo(n - 1));
        // cvcvc
        b = fork(fibo(n - 2));
        co_await sync();
    }
    co_return a.get() + b.get();
"""

"""
Task<int> fibo(int n) {
    int a, b;
    co_return []() -> Join<int> {
        if (n < 2) {
            return n;
        }
        co_await fork(fibo(n - 1), a);
        co_await fork(fibo(n - 2), b);
        co_await Sync();
        co_return a + b;
    }();
}
"""



if __name__ == "__main__":
    print(fibo(20)) # should display 832040