# coding: utf-8
import ast

from transpiler.consts import MAPPINGS
from transpiler.phases.desugar_with import DesugarWith
#from transpiler.phases import initial_pytype
from transpiler.phases.emit_cpp.file import FileVisitor
from transpiler.phases.if_main import IfMainVisitor
from transpiler.phases.typing.block import ScoperBlockVisitor
from transpiler.phases.typing.scope import Scope


def transpile(source):
    res = ast.parse(source, type_comments=True)
    #res = initial_pytype.run(source, res)
    res = DesugarWith().visit(res)
    IfMainVisitor().visit(res)
    ScoperBlockVisitor().visit(res)
    #print(res.scope)

    # display each scope
    def disp_scope(scope, indent=0):
        print("  " * indent, scope.kind)
        for child in scope.children:
            disp_scope(child, indent + 1)
        for var in scope.vars.items():
            print("  " * (indent + 1), var)


    #disp_scope(res.scope)

    code = "\n".join(filter(None, map(str, FileVisitor(Scope()).visit(res))))
    return code

