# coding: utf-8
import ast
from typing import Iterable

from transpiler.phases.emit_cpp.block import BlockVisitor
from transpiler.phases.emit_cpp.module import ModuleVisitor, ModuleVisitor2


# noinspection PyPep8Naming
class FileVisitor(BlockVisitor):
    def visit_Module(self, node: ast.Module) -> Iterable[str]:
        stmt: ast.AST
        yield "#include <python/builtins.hpp>"
        yield "#include <python/sys.hpp>"
        visitor = ModuleVisitor(self.scope)
        code = [line for stmt in node.body for line in visitor.visit(stmt)]
        yield from visitor.includes
        yield "namespace PROGRAMNS {"
        yield from code
        visitor = ModuleVisitor2(self.scope)
        code = [line for stmt in node.body for line in visitor.visit(stmt)]
        yield from code
        yield "}"
        yield "int main(int argc, char* argv[]) {"
        yield "py_sys::all.argv = PyList<PyStr>(std::vector<PyStr>(argv, argv + argc));"
        yield "PROGRAMNS::root().call();"
        yield "}"
